# --MUSARK_AUTH schema

# --- !Ups

CREATE SCHEMA IF NOT EXISTS MUSARK_AUTH;

CREATE TABLE MUSARK_AUTH.AUTH_GROUP (
  group_uuid        VARCHAR2(36) NOT NULL,
  group_name        VARCHAR(100) NOT NULL,
  group_module      INTEGER      NOT NULL,
  group_permission  INTEGER      NOT NULL,
  group_museumId    INTEGER      NOT NULL,
  group_description VARCHAR(512),
  PRIMARY KEY (group_uuid),
  CONSTRAINT unique_group_name UNIQUE (group_name)
);

CREATE TABLE MUSARK_AUTH.MUSEUM_COLLECTION (
  collection_uuid               VARCHAR2(36) NOT NULL,
  collection_name               VARCHAR(100),
  collection_schema_identifiers VARCHAR(100) NOT NULL,
  PRIMARY KEY (collection_uuid),
  CONSTRAINT unique_mcol_name UNIQUE (collection_name)
);

CREATE TABLE MUSARK_AUTH.USER_AUTH_GROUP (
  uag_id           INTEGER GENERATED BY DEFAULT AS IDENTITY,
  user_feide_email VARCHAR(254) NOT NULL,
  group_uuid       VARCHAR2(36) NOT NULL,
  collection_uuid  VARCHAR(36),
  PRIMARY KEY (uag_id),
  FOREIGN KEY (group_uuid) REFERENCES MUSARK_AUTH.AUTH_GROUP (group_uuid),
  FOREIGN KEY (collection_uuid) REFERENCES MUSARK_AUTH.MUSEUM_COLLECTION (collection_uuid),
  CONSTRAINT unique_auth_entry UNIQUE (user_feide_email, group_uuid, collection_uuid)
);

CREATE TABLE MUSARK_AUTH.USER_INFO (
  user_uuid    VARCHAR2(36) NOT NULL,
  secondary_id VARCHAR(512),
  name         VARCHAR(512),
  email        VARCHAR(254),
  picture      VARCHAR(100),
  PRIMARY KEY (user_uuid)
);


INSERT INTO MUSARK_AUTH.MUSEUM_COLLECTION VALUES ('2e4f2455-1b3b-4a04-80a1-ba92715ff613', 'Arkeologi', '[1]');
INSERT INTO MUSARK_AUTH.MUSEUM_COLLECTION VALUES ('88b35138-24b5-4e62-bae4-de80fae7df82', 'Etnografi', '[2]');
INSERT INTO MUSARK_AUTH.MUSEUM_COLLECTION VALUES ('8bbdf9b3-56d1-479a-9509-2ea82842e8f8', 'Numismatikk', '[3]');
INSERT INTO MUSARK_AUTH.MUSEUM_COLLECTION VALUES ('fcb4c598-8b05-4095-ac00-ce66247be38a', 'Lav', '[4]');
INSERT INTO MUSARK_AUTH.MUSEUM_COLLECTION VALUES ('d0dd5ad3-c22f-4ea0-8b52-dc5b0e17aa24', 'Mose', '[5]');
INSERT INTO MUSARK_AUTH.MUSEUM_COLLECTION VALUES ('23ca0166-5f9e-44c2-ab0d-b4cdd704af07', 'Sopp', '[6]');
INSERT INTO MUSARK_AUTH.MUSEUM_COLLECTION VALUES ('1d8dd4e6-1527-439c-ac86-fc315e0ce852', 'Alger', '[7]');
INSERT INTO MUSARK_AUTH.MUSEUM_COLLECTION VALUES ('7352794d-4973-447b-b84e-2635cafe910a', 'Karplanter', '[8]');
INSERT INTO MUSARK_AUTH.MUSEUM_COLLECTION VALUES ('ba3d4d30-810b-4c07-81b3-37751f2196f0', 'Entomologi', '[9]');
INSERT INTO MUSARK_AUTH.MUSEUM_COLLECTION VALUES ('ef4dc066-b6f8-4155-89f8-7aa9aeeb2dc4', 'Marine evertebrater', '[10]');
INSERT INTO MUSARK_AUTH.MUSEUM_COLLECTION VALUES ('c39703f4-c64c-4c13-b92c-67e6af68f674', 'ArkEtno', '[1,2]');

INSERT INTO MUSARK_AUTH.AUTH_GROUP VALUES ('7963557f-e36b-4f12-951d-daa36b3840e1', 'test_test', 1, 20, 99, 'Foo bar baz');
INSERT INTO MUSARK_AUTH.USER_AUTH_GROUP VALUES (999, 'FOOBAR@baz.com', '7963557f-e36b-4f12-951d-daa36b3840e1', '2e4f2455-1b3b-4a04-80a1-ba92715ff613');
# --- !Downs
